<template>
	<div class="depths-form stack">
		<component :is="single ? 'div' : 'v-card'" class="depth" v-for="(depth, i) in depths" :key="i">
			<component :is="single ? 'div' : 'v-card-text'">
				<v-row>
					<v-col>
						<v-text-field
							type="number"
							label="Min Depth"
							@input="(val) => onEditDepth(i)(modifyDepth(depth, 'minValue')(Number(val)))"
							:value="depth.minValue"
						/>
					</v-col>
					<v-col>
						<v-text-field
							type="number"
							label="Max Depth"
							@input="(val) => onEditDepth(i)(modifyDepth(depth, 'maxValue')(Number(val)))"
							:value="depth.maxValue"
						/>
					</v-col>
					<v-col class="flex-grow-0">
						<v-select
							label="Units"
							@input="(val) => onEditDepth(i)(modifyDepth(depth, 'unit')(val))"
							:items="units"
							:value="depth.unit"
							:disabled="true"
						/>
					</v-col>
					<v-col class="flex-grow-0" v-if="!single">
						<v-btn icon @click="() => onRemoveDepth(i)">
							<v-icon>mdi-delete</v-icon>
						</v-btn>
					</v-col>
				</v-row>
			</component>
		</component>
		<div class="d-flex justify-end" v-if="!single">
			<v-btn @click="onAddDepth" rounded color="white"> + Add Depth </v-btn>
		</div>
	</div>
	<!-- <v-form>
		<
	</v-form> -->
</template>

<script lang="ts">
import { defineComponent, computed, ComputedRef } from '@vue/composition-api';
import { SoDepth } from '@/store/types';

function createDepth() {
	return {
		minValue: 0,
		maxValue: 0,
		unit: 'unit:CM',
	};
}

const modifyDepth = (depth: Depth, key: keyof Depth) => (value: string | number): Depth => {
	return {
		...depth,
		[key]: value,
	};
};

interface Depth {
	maxValue: number;
	minValue: number;
	unit: string;
}

export default defineComponent({
	props: {
		items: {
			type: Array as () => SoDepth[],
			default: [],
		},
		single: {
			type: Boolean,
			default: false,
		},
	},
	setup(props, { emit }) {
		const depths: ComputedRef<Depth[]> = computed(() =>
			props.items.map((depth: SoDepth) => ({
				minValue: depth.minValue.value,
				maxValue: depth.maxValue.value,
				unit: depth.minValue.unit || depth.maxValue.unit,
			}))
		);

		const units = [
			{
				value: 'unit:CM',
				text: 'cm',
			},
			{
				value: 'unit:IN',
				text: 'in',
			},
		];

		function emitDepths(depths: Depth[]) {
			emit(
				'setDepths',
				depths.map((depth: Depth) => ({
					minValue: {
						value: depth.minValue,
						unit: depth.unit,
					},
					maxValue: {
						value: depth.maxValue,
						unit: depth.unit,
					},
				}))
			);
		}

		function onAddDepth() {
			const newDepths = [...depths.value, createDepth()];
			emitDepths(newDepths);
		}

		const onEditDepth = (index: number) => (depth: Depth) => {
			const newDepths = [...depths.value.slice(0, index), depth, ...depths.value.slice(index + 1)];
			emitDepths(newDepths);
		};

		const onRemoveDepth = (index: number) => {
			const newDepths = [...depths.value.slice(0, index), ...depths.value.slice(index + 1)];
			emitDepths(newDepths);
		};

		return {
			depths,
			units,
			onAddDepth,
			onRemoveDepth,
			onEditDepth,
			modifyDepth,
		};
	},
});
</script>

<style scoped>
.stack > * + * {
	margin-top: 1rem;
}
</style>
